// test.cpp : Defines the entry point for the console application.
//

#include <windows.h>
#include <stdio.h>
#include <string>
#include <vector>
using namespace std;
#include <conio.h>

#if _WIN64
#pragma comment( lib, "../bin/spl2pdfsdk64.lib" )
#else
#pragma comment( lib, "../bin/spl2pdfsdk.lib" )
#endif

extern "C" __declspec(dllexport)
int WINAPI VeryPDFSPL2PDFConverterW(const wchar_t *lpszCmdLineW);
extern "C" __declspec(dllexport)
int WINAPI VeryPDFSPL2PDFConverter(const char *lpszCmdLine);

std::wstring strtowstr(const std::string str)
{
    // Convert an ASCII string to a Unicode String
	int nLength = str.length()*2+1;
    std::wstring wstrTo;
    wchar_t *wszTo = new wchar_t[nLength];
    memset(wszTo, 0, sizeof(wchar_t)*nLength);
    MultiByteToWideChar(CP_ACP, 0, str.c_str(), -1, wszTo, (int)nLength);
    wstrTo = wszTo;
    delete[] wszTo;
    return wstrTo;
}

int main(int argc, char* argv[])
{
	if(argc == 1)
	{
		printf("Usage: [options] <in-file> [<out-file>]\n");
		return 0;
	}
	char szCmdBuf[2048] = {0};
	for(int i = 1; i < argc; i++)
	{
		strcat(szCmdBuf, "\"");
		strcat(szCmdBuf, argv[i]);
		strcat(szCmdBuf, "\" ");
	}

	int nRet = 0;
	{
		wstring wstrCmd = strtowstr(szCmdBuf);
		nRet = VeryPDFSPL2PDFConverterW(wstrCmd.c_str());
	}
	printf("Press any key to continue...\n");
	_getch();
	{
		nRet = VeryPDFSPL2PDFConverter(szCmdBuf);
	}
	printf("nRet = %d\n",nRet);
	return 0;
}
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPTSTR lpCmdLine, int nCmdShow)
{
	return main(__argc,__argv);
}
